use log::info;
use noteposter::{http::Target, key::Key, signed_post};
use std::path::Path;
use ureq::http::{HeaderMap, HeaderValue, header::CONTENT_TYPE};

fn main() {
    let host = "estradiol.city";
    let path = Path::new("/users/ity/inbox");

    let key_id = "https://testing4host.com/users/test71/#main-key";

    let key = Key::from_files(
        "private.pem".into(),
        "public.pem".into(),
        key_id.to_string(),
    )
    .expect("Failed to read key files");

    let (_status, res) = signed_post(
        key,
        Target { host, path },
        {
            let mut headers = HeaderMap::new();
            headers.insert(
                CONTENT_TYPE,
                HeaderValue::from_static("application/activity+json"),
            );
            headers
        },
        include_bytes!("note.json"),
    );

    info!(
        "Response: {}",
        String::from_utf8(res).expect("Invalid response: decode error")
    );
}
